Enabling ftrace for kernel debugging.
[kvmfornfv.git] / ci / test_kvmfornfv.sh
index e507f37..e87d6eb 100755 (executable)
 #!/bin/bash
 
-#############################################################
-## This script  will launch ubuntu docker container
-## runs cyclictest through yardstick
-## and verifies the test results.
+############################################################
+## This script  is an interface to trigger the
+## cyclicTestTrigger.sh for test type like patch verification,
+## daily testing.
+## Releng will trigger this script by passing test type as
+## verify/daily and test name as idle_idle/stress_idle/
+## packet_forward as arguments.
+## Verify Job runs idle_idle,packet_forward test
+## daily job runs base on the test name parameter
 ############################################################
 
-docker_image_dir=$WORKSPACE/docker_image_build
-function env_clean {
-    container_id=`sudo docker ps -a | grep kvmfornfv |awk '{print $1}'`
-    sudo docker rm $container_id
-    sudo ssh root@10.2.117.23 "rm -rf /root/workspace/*"
-    sudo ssh root@10.2.117.23 "pid=\$(ps aux | grep 'qemu' | awk '{print \$2}' | head -1); echo \$pid |xargs kill"
-    sudo rm -rf /tmp/kvmtest-*
-}
-
-#Cleaning up the test environment before running cyclictest through yardstick.
-env_clean
-
-#Creating a docker image with yardstick installed.
-( cd ${docker_image_dir}; sudo docker build  -t kvmfornfv:latest --no-cache=true . )
-if [ ${?} -ne 0 ] ; then
-    echo  "Docker image build failed"
-    id=$(sudo docker ps -a  | head  -2 | tail -1 | awk '{print $1}'); sudo docker rm -f $id
-    exit 1
-fi
-
-time_stamp=$(date +%Y%m%d%H%M%S)
-volume=/tmp/kvmtest-${time_stamp}
-mkdir -p $volume/{image,rpm,scripts}
+test_type=$1
+test_name=$2
+ftrace_enable=0
+cyclictest_env_verify=("idle_idle" "cpustress_idle" "memorystress_idle" "iostress_idle") #cyclictest environment
+cyclictest_env_daily=("idle_idle" "cpustress_idle" "memorystress_idle" "iostress_idle")
+cyclictest_result=0 #exit code of cyclictest
+packetforward_result=0 #exit code of packet forward
+source $WORKSPACE/ci/envs/host-config
 
-#copying required files to run yardstick cyclic testcase
-mv $WORKSPACE/build_output/kernel-4.4*.rpm $volume/rpm
-cp -r $WORKSPACE/ci/envs/* $volume/scripts
-cp -r $WORKSPACE/tests/cyclictest-node-context.yaml $volume
-cp -r $WORKSPACE/tests/pod.yaml $volume
+function packetForward {
+#   source $WORKSPACE/ci/packet_forward_test.sh $HOST_IP
+   echo "Packetforwarding need to be implemented"
+   packetforward_result=$?
+   if [ ${packetforward_result} -ne 0 ];then
+      echo "Packet Forwarding test case execution FAILED"
+   else
+      echo "Packet Forwarding test case executed SUCCESSFULLY"
+   fi
+   host_clean
+}
 
-#Launching ubuntu docker container to run yardstick
-sudo docker run -i -v $volume:/opt --net=host --name kvmfornfv \
-kvmfornfv:latest  /bin/bash -c "cd /opt/scripts && ls; ./cyclictest.sh"
+function cyclictest {
+   test_case=$1
+   source $WORKSPACE/ci/cyclicTestTrigger.sh $HOST_IP $test_time $test_type $test_case
+   #calculating and verifying sha512sum of the guestimage.
+   if ! verifyGuestImage;then
+      exit 1
+   fi
+   #Update kvmfornfv_cyclictest_${testName}.yaml with test_time and pod.yaml with IP
+   updateYaml
+   #Cleaning up the test environment before running cyclictest through yardstick.
+   env_clean
+   #Creating a docker image with yardstick installed and launching ubuntu docker to run yardstick cyclic testcase
+   if runCyclicTest;then
+      cyclictest_result=`expr ${cyclictest_result} + 0`
+   else
+      echo "Test case execution FAILED for ${test_case} environment"
+      cyclictest_result=`expr ${cyclictest_result} + 1`
+   fi
+}
 
-#Verifying the results of cyclictest
-result=`grep -o '"errors":[^,]*' $volume/yardstick.out | awk -F '"' '{print $4}'`
+function ftrace_disable {
+   sudo ssh root@${HOST_IP} "sh /root/workspace/scripts/disbale-trace.sh"
+   sudo ssh root@${HOST_IP} "cd /tmp ; a=\$(ls -rt | tail -1) ; echo \$a ; mv \$a cyclictest_${env}.txt"
+   sudo mkdir -p $WORKSPACE/build_output/log/kernel_trace
+   sudo scp root@${HOST_IP}:/tmp/cyclictest_${env}.txt $WORKSPACE/build_output/log/kernel_trace/
+}
 
-if [ -z "$result" ]; then
-    echo "####################################################"
-    echo ""
-    echo `grep -o '"data":[^}]*' $volume/yardstick.out | awk -F '{' '{print $2}'`
-    echo ""
-    echo "####################################################"
-    env_clean
-    exit 0
+#Execution of testcases based on test type and test name from releng.
+if [ ${test_type} == "verify" ];then
+   HOST_IP="10.10.100.21"
+   test_time=120000 # 2m
+   if [ ${ftrace_enable} -eq '1' ]; then
+      for env in ${cyclictest_env_verify[@]}
+      do
+         #Enabling ftrace for kernel debugging.
+         sed -i '/host-setup1.sh/a\    \- \"enable-trace.sh\"' kvmfornfv_cyclictest_hostenv_guestenv.yaml
+         #Executing cyclictest through yardstick.
+         cyclictest ${env}
+         #disabling ftrace and collecting the logs to upload to artifact repository.
+         ftrace_disable
+         sleep 10
+      done
+      #Execution of packet forwarding test cases.
+      packetForward
+   else
+      for env in ${cyclictest_env_verify[@]}
+      do
+         #Executing cyclictest through yardstick.
+         cyclictest ${env}
+         sleep 10
+      done
+      #Execution of packet forwarding test cases.
+      packetForward
+   fi
+      if [ ${cyclictest_result} -ne 0 ] ||  [ ${packetforward_result} -ne 0 ];then
+         echo "Test case FAILED"
+         err_exit 1
+      else
+         err_exit 0
+      fi
+elif [ ${test_type} == "daily" ];then
+   HOST_IP="10.10.100.22"
+   test_time=3600000 #1h
+   if [ ${test_name} == "packet_forward" ];then
+      packetForward
+      if [ ${packetforward_result} -ne 0 ] ; then
+         err_exit 1
+      else
+         err_exit 0
+      fi
+   elif [ ${test_name} == "cyclictest" ];then
+      if [ ${ftrace_enable} -eq '1' ]; then
+         for env in ${cyclictest_env_daily[@]}
+         do
+            #Enabling ftrace for kernel debugging.
+            sed -i '/host-setup1.sh/a\    \- \"enable-trace.sh\"' kvmfornfv_cyclictest_hostenv_guestenv.yaml
+            #Executing cyclictest through yardstick.
+            cyclictest ${env}
+            #disabling ftrace and collecting the logs to upload to artifact repository. 
+            ftrace_disable
+            sleep 5
+         done
+      else
+         for env in ${cyclictest_env_daily[@]}
+         do
+         #Executing cyclictest through yardstick.
+         cyclictest ${env}
+         sleep 5
+         done
+      fi
+         if [ ${cyclictest_result} -ne 0 ] ; then
+            echo "Cyclictest case execution FAILED"
+            err_exit 1
+         else
+            echo "Cyclictest case executed SUCCESSFULLY"
+            err_exit 0
+         fi
+   fi
+elif [ ${test_type} == "merge" ];then
+   echo "Test is not enabled for ${test_type}"
+   exit 0
 else
-    echo "Testcase failed"
-    echo `grep -o '"errors":[^,]*' ${volume}/yardstick.out | awk -F '"' '{print $4}'`
-    env_clean
-    exit 1
+   echo "Incorrect test type ${test_type}"
 fi